# Taskwise Model Decomposition for Personalized Federated Learning

Research code that accompanies the paper [Taskwise Model Decomposition for Personalized Federated Learning].

## Install Requirements:
```pip3 install -r requirements.txt```

  
## Prepare Dataset: 
* To generate *non-iid* **Mnist** Dataset following the Pathological distribution for 20 clients:
<pre><code>cd pFedC-code/data/Mnist
python generate_niid_class_mtl.py --n_class 10 --class_per_client 2 --n_user 20
### This will generate a dataset located at pFedC/data/Mnist/u20c10-mtl-class2/
</code></pre>

* To generate *non-iid* **Mnist** Dataset following the Dirichlet distribution D(&alpha;=0.1) for 20 clients, using 50% of the total available training samples:
<pre><code>cd pFedC-code/data/Mnist
python generate_niid_dirichlet_mtl.py --n_class 10 --sampling_ratio 0.5 --alpha 0.1 --n_user 20
### This will generate a dataset located at pFedC-code/data/Mnist/u20c10-mtl-alpha0.1-ratio0.5/
</code></pre>


## Run Experiments: 

There is a main file "main.py" which allows running all experiments.

#### Run experiments on the *Mnist* Dataset:
```
python main.py --dataset Mnist-alpha0.1-ratio0.5 --algorithm pFedC --batch_size 32 --num_glob_iters 200 --local_epochs 20 --num_users 10 --lamda 1 --learning_rate 0.01 --model cnn --personal_learning_rate 0.01 --times 3 
```
----

##### Run experiments on the *EMnist* Dataset:
```
python main.py --dataset EMnist-alpha0.1-ratio0.1 --algorithm FedAvg --batch_size 32 --local_epochs 20 --num_users 10 --lamda 1 --model cnn --learning_rate 0.01 --personal_learning_rate 0.01 --num_glob_iters 200 --times 3 
```
----

### Plot
For the input attribute **algorithms**, list the name of algorithms and separate them by comma, e.g. `--algorithms FedAvg,pFedC,pFedMe`
```
  python main_plot.py --dataset EMnist-alpha0.1-ratio0.1 --algorithms FedAvg,pFedC --batch_size 32 --local_epochs 20 --num_users 10 --num_glob_iters 200 --plot_legend 1
```
